/* capability-group.c generated by valac 0.56.15, the Vala compiler
 * generated from capability-group.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */

#include "gnome-pomodoro.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	POMODORO_CAPABILITY_GROUP_0_PROPERTY,
	POMODORO_CAPABILITY_GROUP_NAME_PROPERTY,
	POMODORO_CAPABILITY_GROUP_NUM_PROPERTIES
};
static GParamSpec* pomodoro_capability_group_properties[POMODORO_CAPABILITY_GROUP_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	POMODORO_CAPABILITY_GROUP_CAPABILITY_ADDED_SIGNAL,
	POMODORO_CAPABILITY_GROUP_CAPABILITY_REMOVED_SIGNAL,
	POMODORO_CAPABILITY_GROUP_NUM_SIGNALS
};
static guint pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_NUM_SIGNALS] = {0};

struct _PomodoroCapabilityGroupPrivate {
	gchar* _name;
	GHashTable* capabilities;
};

static gint PomodoroCapabilityGroup_private_offset;
static gpointer pomodoro_capability_group_parent_class = NULL;

static GObject * pomodoro_capability_group_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void pomodoro_capability_group_finalize (GObject * obj);
static GType pomodoro_capability_group_get_type_once (void);
static void _vala_pomodoro_capability_group_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_pomodoro_capability_group_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

static inline gpointer
pomodoro_capability_group_get_instance_private (PomodoroCapabilityGroup* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroCapabilityGroup_private_offset);
}

PomodoroCapabilityGroup*
pomodoro_capability_group_construct (GType object_type,
                                     const gchar* name)
{
	PomodoroCapabilityGroup * self = NULL;
	self = (PomodoroCapabilityGroup*) g_object_new (object_type, NULL);
	pomodoro_capability_group_set_name (self, name);
	return self;
}

PomodoroCapabilityGroup*
pomodoro_capability_group_new (const gchar* name)
{
	return pomodoro_capability_group_construct (POMODORO_TYPE_CAPABILITY_GROUP, name);
}

gboolean
pomodoro_capability_group_contains (PomodoroCapabilityGroup* self,
                                    const gchar* capability_name)
{
	GHashTable* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (capability_name != NULL, FALSE);
	_tmp0_ = self->priv->capabilities;
	result = g_hash_table_contains (_tmp0_, capability_name);
	return result;
}

PomodoroCapability*
pomodoro_capability_group_lookup (PomodoroCapabilityGroup* self,
                                  const gchar* capability_name)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	PomodoroCapability* _tmp2_;
	PomodoroCapability* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (capability_name != NULL, NULL);
	_tmp0_ = self->priv->capabilities;
	_tmp1_ = g_hash_table_lookup (_tmp0_, capability_name);
	_tmp2_ = (PomodoroCapability*) _tmp1_;
	result = POMODORO_IS_CAPABILITY (_tmp2_) ? ((PomodoroCapability*) _tmp2_) : NULL;
	return result;
}

void
pomodoro_capability_group_foreach (PomodoroCapabilityGroup* self,
                                   GHFunc func,
                                   gpointer func_target)
{
	GHashTable* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->capabilities;
	g_hash_table_foreach (_tmp0_, func, func_target);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gboolean
pomodoro_capability_group_add (PomodoroCapabilityGroup* self,
                               PomodoroCapability* capability)
{
	PomodoroCapability* existing_capability = NULL;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gconstpointer _tmp3_;
	PomodoroCapability* _tmp4_;
	PomodoroCapability* _tmp5_;
	GHashTable* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	PomodoroCapability* _tmp10_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (capability != NULL, FALSE);
	_tmp0_ = self->priv->capabilities;
	_tmp1_ = pomodoro_capability_get_name (capability);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_hash_table_lookup (_tmp0_, _tmp2_);
	_tmp4_ = _g_object_ref0 ((PomodoroCapability*) _tmp3_);
	existing_capability = _tmp4_;
	_tmp5_ = existing_capability;
	if (_tmp5_ != NULL) {
		result = FALSE;
		_g_object_unref0 (existing_capability);
		return result;
	}
	_tmp6_ = self->priv->capabilities;
	_tmp7_ = pomodoro_capability_get_name (capability);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strdup (_tmp8_);
	_tmp10_ = _g_object_ref0 (capability);
	g_hash_table_insert (_tmp6_, _tmp9_, _tmp10_);
	pomodoro_capability_set_group (capability, self);
	g_signal_emit (self, pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_ADDED_SIGNAL], 0, capability);
	result = TRUE;
	_g_object_unref0 (existing_capability);
	return result;
}

void
pomodoro_capability_group_replace (PomodoroCapabilityGroup* self,
                                   PomodoroCapability* capability)
{
	PomodoroCapability* existing_capability = NULL;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gconstpointer _tmp3_;
	PomodoroCapability* _tmp4_;
	PomodoroCapability* _tmp5_;
	PomodoroCapability* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (capability != NULL);
	_tmp0_ = self->priv->capabilities;
	_tmp1_ = pomodoro_capability_get_name (capability);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_hash_table_lookup (_tmp0_, _tmp2_);
	_tmp4_ = _g_object_ref0 ((PomodoroCapability*) _tmp3_);
	existing_capability = _tmp4_;
	_tmp5_ = existing_capability;
	if (_tmp5_ == capability) {
		_g_object_unref0 (existing_capability);
		return;
	}
	_tmp6_ = existing_capability;
	if (_tmp6_ == NULL) {
		GHashTable* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		PomodoroCapability* _tmp11_;
		_tmp7_ = self->priv->capabilities;
		_tmp8_ = pomodoro_capability_get_name (capability);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strdup (_tmp9_);
		_tmp11_ = _g_object_ref0 (capability);
		g_hash_table_insert (_tmp7_, _tmp10_, _tmp11_);
	} else {
		GHashTable* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		PomodoroCapability* _tmp16_;
		PomodoroCapability* _tmp17_;
		_tmp12_ = self->priv->capabilities;
		_tmp13_ = pomodoro_capability_get_name (capability);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strdup (_tmp14_);
		_tmp16_ = _g_object_ref0 (capability);
		g_hash_table_replace (_tmp12_, _tmp15_, _tmp16_);
		_tmp17_ = existing_capability;
		g_signal_emit (self, pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_REMOVED_SIGNAL], 0, _tmp17_);
	}
	pomodoro_capability_set_group (capability, self);
	g_signal_emit (self, pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_ADDED_SIGNAL], 0, capability);
	_g_object_unref0 (existing_capability);
}

void
pomodoro_capability_group_remove (PomodoroCapabilityGroup* self,
                                  const gchar* capability_name)
{
	PomodoroCapability* capability = NULL;
	PomodoroCapability* _tmp0_;
	PomodoroCapability* _tmp1_;
	PomodoroCapability* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (capability_name != NULL);
	_tmp0_ = pomodoro_capability_group_lookup (self, capability_name);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	capability = _tmp1_;
	_tmp2_ = capability;
	if (_tmp2_ != NULL) {
		GHashTable* _tmp3_;
		PomodoroCapability* _tmp4_;
		_tmp3_ = self->priv->capabilities;
		g_hash_table_remove (_tmp3_, capability_name);
		_tmp4_ = capability;
		g_signal_emit (self, pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_REMOVED_SIGNAL], 0, _tmp4_);
	}
	_g_object_unref0 (capability);
}

void
pomodoro_capability_group_remove_all (PomodoroCapabilityGroup* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->capabilities;
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
	{
		GList* capability_name_collection = NULL;
		GList* capability_name_it = NULL;
		capability_name_collection = _tmp1_;
		for (capability_name_it = capability_name_collection; capability_name_it != NULL; capability_name_it = capability_name_it->next) {
			const gchar* capability_name = NULL;
			capability_name = (const gchar*) capability_name_it->data;
			{
				const gchar* _tmp2_;
				_tmp2_ = capability_name;
				pomodoro_capability_group_remove (self, _tmp2_);
			}
		}
		(capability_name_collection == NULL) ? NULL : (capability_name_collection = (g_list_free (capability_name_collection), NULL));
	}
}

const gchar*
pomodoro_capability_group_get_name (PomodoroCapabilityGroup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
pomodoro_capability_group_set_name (PomodoroCapabilityGroup* self,
                                    const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = pomodoro_capability_group_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pomodoro_capability_group_properties[POMODORO_CAPABILITY_GROUP_NAME_PROPERTY]);
	}
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static GObject *
pomodoro_capability_group_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroCapabilityGroup * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	parent_class = G_OBJECT_CLASS (pomodoro_capability_group_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_CAPABILITY_GROUP, PomodoroCapabilityGroup);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (self->priv->capabilities);
	self->priv->capabilities = _tmp2_;
	return obj;
}

static void
pomodoro_capability_group_class_init (PomodoroCapabilityGroupClass * klass,
                                      gpointer klass_data)
{
	pomodoro_capability_group_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PomodoroCapabilityGroup_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_capability_group_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_capability_group_set_property;
	G_OBJECT_CLASS (klass)->constructor = pomodoro_capability_group_constructor;
	G_OBJECT_CLASS (klass)->finalize = pomodoro_capability_group_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_CAPABILITY_GROUP_NAME_PROPERTY, pomodoro_capability_group_properties[POMODORO_CAPABILITY_GROUP_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_ADDED_SIGNAL] = g_signal_new ("capability-added", POMODORO_TYPE_CAPABILITY_GROUP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POMODORO_TYPE_CAPABILITY);
	pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_REMOVED_SIGNAL] = g_signal_new ("capability-removed", POMODORO_TYPE_CAPABILITY_GROUP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POMODORO_TYPE_CAPABILITY);
}

static void
pomodoro_capability_group_instance_init (PomodoroCapabilityGroup * self,
                                         gpointer klass)
{
	self->priv = pomodoro_capability_group_get_instance_private (self);
}

static void
pomodoro_capability_group_finalize (GObject * obj)
{
	PomodoroCapabilityGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_CAPABILITY_GROUP, PomodoroCapabilityGroup);
	_g_free0 (self->priv->_name);
	_g_hash_table_unref0 (self->priv->capabilities);
	G_OBJECT_CLASS (pomodoro_capability_group_parent_class)->finalize (obj);
}

static GType
pomodoro_capability_group_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroCapabilityGroupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_capability_group_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroCapabilityGroup), 0, (GInstanceInitFunc) pomodoro_capability_group_instance_init, NULL };
	GType pomodoro_capability_group_type_id;
	pomodoro_capability_group_type_id = g_type_register_static (G_TYPE_OBJECT, "PomodoroCapabilityGroup", &g_define_type_info, 0);
	PomodoroCapabilityGroup_private_offset = g_type_add_instance_private (pomodoro_capability_group_type_id, sizeof (PomodoroCapabilityGroupPrivate));
	return pomodoro_capability_group_type_id;
}

GType
pomodoro_capability_group_get_type (void)
{
	static volatile gsize pomodoro_capability_group_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_capability_group_type_id__once)) {
		GType pomodoro_capability_group_type_id;
		pomodoro_capability_group_type_id = pomodoro_capability_group_get_type_once ();
		g_once_init_leave (&pomodoro_capability_group_type_id__once, pomodoro_capability_group_type_id);
	}
	return pomodoro_capability_group_type_id__once;
}

static void
_vala_pomodoro_capability_group_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	PomodoroCapabilityGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_CAPABILITY_GROUP, PomodoroCapabilityGroup);
	switch (property_id) {
		case POMODORO_CAPABILITY_GROUP_NAME_PROPERTY:
		g_value_set_string (value, pomodoro_capability_group_get_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_pomodoro_capability_group_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	PomodoroCapabilityGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_CAPABILITY_GROUP, PomodoroCapabilityGroup);
	switch (property_id) {
		case POMODORO_CAPABILITY_GROUP_NAME_PROPERTY:
		pomodoro_capability_group_set_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

